//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

#include "KT_PostProcess_Common.fx"

//------------------------------------------------------------------------------------------------------
//- Static parameters
//------------------------------------------------------------------------------------------------------

float4 GlobalColor;

sampler2D DiffuseSampler = 
sampler_state
{
    Texture		= <SourceTexture1>;
    MinFilter	= LINEAR;
    MagFilter	= LINEAR;
    MipFilter	= NONE; //no mipmaps.
    AddressU	= CLAMP;
    AddressV	= CLAMP;
};


sampler2D NormalSampler = 
sampler_state
{
    Texture		= <SourceTexture2>;
    MinFilter	= LINEAR;
    MagFilter	= LINEAR;
    MipFilter	= NONE; //no mipmaps.
    AddressU	= CLAMP;
    AddressV	= CLAMP;
};


float4 PSScreenDistortion( VS_PostProcess_Output2 input ):COLOR0
{
	float4 Normal = 2.0f*(tex2D(NormalSampler , input.DiffuseUv2)-0.5f);
	float2 DiffuseUV = saturate(input.DiffuseUv1 + 0.05f*Normal.xy);

    return tex2D(DiffuseSampler, DiffuseUV);
}


//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
technique TestExo
<
	int Priority = 1;
	int TechniqueIndex = 0;
	int DeviceType = HWSHADER_ONLY;
	int LightingType = INTEGRATED_LIGHTING;
	string RenderingType = "Standard";
>
{
	pass pass1
	{
		Sampler[0] = <DiffuseSampler>;
		Sampler[1] = <NormalSampler>;
        
		AlphaBlendEnable	= false;
		AlphaTestEnable		= false;
		FogEnable			= false;
		
		CullMode			= NONE;
		ZEnable				= false;
		ZWriteEnable		= false;
		
		VertexShader = compile vs_1_1 VSBaseScreenCorrected2();
		PixelShader  = compile ps_2_0 PSScreenDistortion();
	}
}


//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
