//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

#include "shared.fx"
#include "orientable_particle.fx"

//------------------------------------------------------------------------------------------------------
//- Static parameters
//------------------------------------------------------------------------------------------------------

texture	ParticleTexture;

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

sampler ParticleTextureSampler = sampler_state
{
	Texture		= <ParticleTexture>;
	MinFilter	= LINEAR;
	MagFilter	= LINEAR;
	MipFilter	= POINT;
	AddressU	= CLAMP;
    AddressV	= CLAMP;
};

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

#define AdditiveRenderStateBlock \
	CullMode			= NONE; \
	ZEnable				= true; \
	ZFunc				= LESSEQUAL; \
	ZWriteEnable		= false; \
	AlphaBlendEnable	= true; \
	SrcBlend			= SRCALPHA; \
    DestBlend			= INVSRCALPHA; \
	AlphaTestEnable		= true; \
	AlphaRef			= 0; \
	AlphaFunc			= GREATER; \
	FOG_OPTION_PARAMETERS

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

technique	tech1
<
	int TechniqueIndex = 0;
	int DeviceType = TNL_AND_HWSHADER;
	int	NeedSorting = 1;
	string RenderingType = "Standard";
>
{
	pass pass1
	{
        Sampler[0]	= <ParticleTextureSampler>;

        AdditiveRenderStateBlock;
	
		VertexShader = compile vs_1_1 OrientableParticleVSProcess();
		
		PixelShader = 
		asm
		{
			ps_1_1
			
			tex		t0	// Particle map
			
			//mul	r0.rgb,t0,v0 + mov r0.a,v0
			mul	r0.rgb,t0,v0 + mul r0.a,v0,t0
			mul	r0.rgb,r0,r0.a
		};
	}
}

technique	tech2
<
	int TechniqueIndex = 0;
	int DeviceType = TNL_AND_HWSHADER;
	int	NeedSorting = 1;
	string RenderingType = "Standard";
>
{
	pass pass1
	{
		Sampler[0] = <ParticleTextureSampler>;
		
		AdditiveRenderStateBlock;
		
		ColorArg1[0]		= DIFFUSE | ALPHAREPLICATE;
		ColorArg2[0]		= TEXTURE;
		ColorOp[0]			= MODULATE;
		AlphaArg1[0]		= DIFFUSE;
		AlphaArg1[0]		= TEXTURE;
		AlphaOp[0]			= MODULATE;
		
		ColorArg1[1]		= DIFFUSE;
		ColorArg2[1]		= CURRENT;
		ColorOp[1]			= MODULATE;
		AlphaArg1[1]		= CURRENT;
		AlphaOp[1]			= SELECTARG1;
		
		ColorOp[2]			= DISABLE;
		AlphaOp[2]			= DISABLE;
		
		VertexShader = compile vs_1_1 OrientableParticleVSProcess();
		PixelShader = NULL;
	}
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------