//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

#include "shared.fx"
#include "lighting.fx"
#include "fog.fx"

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

struct	CVertexShaderInput
{
	float4	Position	:	POSITION;
};

//------------------------------------------------------------------------------------------------------

struct	CVertexShaderOutput
{
	float4	Position			:	POSITION;
};

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

CVertexShaderOutput	Null_Material	(const CVertexShaderInput input);

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

CVertexShaderOutput	Null_Material (const CVertexShaderInput input)
{
	CVertexShaderOutput output;
	
	// output position into world+view+projection space
	output.Position = mul (input.Position,WorldCameraProjection);
		
	return output;
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------


technique	tech1
<
	int TechniqueIndex = 0;
	int DeviceType = HWSHADER_ONLY;
	int LightingType = INTEGRATED_LIGHTING;
	string RenderingType = "Standard";
>
{
	pass pass1
	{
		TextureFactor		= <SpecularColor>;
		CullMode			= CW;
		ZEnable				= true;
		ZFunc				= ALWAYS;
		ZWriteEnable		= false;
		AlphaBlendEnable	= true;
		SrcBlend			= SRCALPHA;
        DestBlend			= INVSRCALPHA;
		ColorArg1[0]		= TFACTOR;
		ColorOp[0]			= SELECTARG1;
		AlphaArg1[0]		= TFACTOR;
		AlphaOp[0]			= SELECTARG1;
				
		VertexShader = compile vs_1_1 Null_Material();
		
		PixelShader = NULL;
	}
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

technique	tech2_TnL
<
	int TechniqueIndex = 0;
	int DeviceType = TNL_ONLY;
	int LightingType = INTEGRATED_LIGHTING;
	string RenderingType = "Standard";
>
{
	pass pass1
	{
		WorldTransform[0]	= <WorldCameraProjection>;
		IndexedVertexBlendEnable = false;
		
		ColorArg1[0]		= DIFFUSE;
		ColorOp[0]		= SELECTARG1;
		AlphaArg1[0]		= DIFFUSE;
		AlphaOp[0]		= SELECTARG1;
		ColorOp[1]		= DISABLE;
		AlphaOp[1]		= DISABLE;
				
		CullMode		= CW;
		ZEnable			= true;
		ZFunc			= ALWAYS;
		ZWriteEnable		= false;
		AlphaBlendEnable	= true;
		SrcBlend		= SRCALPHA;
		DestBlend		= INVSRCALPHA;
				
		VertexShader 		= NULL;		
		PixelShader 		= NULL;
	}
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

#include "mesh_shadow.fx"
#include "mesh_shadow_projector.fx"

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------