//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

#include "shared.fx"

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

texture	TextureToSoften;

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

struct	CVertexShaderSoftenShadowInput
{
	float4	Position	:	POSITION;
	float2	UvSample0	:	TEXCOORD0;
	float2	UvSample1	:	TEXCOORD1;
	float2	UvSample2	:	TEXCOORD2;
	float2	UvSample3	:	TEXCOORD3;
};

//------------------------------------------------------------------------------------------------------

struct	CVertexShaderSoftenShadowOutput
{
	float4	Position	:	POSITION;
	float2	UvSample0	:	TEXCOORD0;
	float2	UvSample1	:	TEXCOORD1;
	float2	UvSample2	:	TEXCOORD2;
	float2	UvSample3	:	TEXCOORD3;
};

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

CVertexShaderSoftenShadowOutput	VSSoftenShadow	(const CVertexShaderSoftenShadowInput input);

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

CVertexShaderSoftenShadowOutput	VSSoftenShadow	(const CVertexShaderSoftenShadowInput input)
{
	CVertexShaderSoftenShadowOutput	output;

	output.Position = input.Position;
	output.UvSample0 = input.UvSample0;
	output.UvSample1 = input.UvSample1;
	output.UvSample2 = input.UvSample2;
	output.UvSample3 = input.UvSample3;
	
	return output;
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

sampler SoftenSampler = sampler_state
{
	Texture		= <TextureToSoften>;
	MinFilter	= LINEAR;
	MagFilter	= LINEAR;
	//MinFilter	= POINT;
	//MagFilter	= POINT;
	MipFilter	= NONE;
	AddressU	= CLAMP;
    AddressV	= CLAMP;
};

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
/*
technique	tech_soften_shadow_PS20_Pass1
<
	int Priority = 1;
	int TechniqueIndex = 0;
	int DeviceType = HWSHADER_ONLY;
	int LightingType = INTEGRATED_LIGHTING;
	string RenderingType = "Shadow";
>
{
	pass pass1
	{
		CullMode			= NONE;
		ZEnable				= false;
		ZWriteEnable		= false;
		AlphaBlendEnable	= false;
		AlphaTestEnable		= false;
		
		Sampler[0]	= <SoftenSampler>;
		Sampler[1]	= <SoftenSampler>;
		Sampler[2]	= <SoftenSampler>;
		Sampler[3]	= <SoftenSampler>;
		
		VertexShader = compile vs_1_1 VSSoftenShadow();
		
		PixelShaderConstant[0]	= {0.25f,0.0f,0.0f,0.0f};
		
		PixelShader = 
		asm
		{
			ps_2_0
	
			dcl		t0.rg
			dcl		t1.rg
			dcl		t2.rg
			dcl		t3.rg
			dcl_2d	s0
			dcl_2d	s1
			dcl_2d	s2
			dcl_2d	s3
			
			texld	r0,t0,s0
			
			
			texld	r1,t1,s1
			texld	r2,t2,s2
			texld	r3,t3,s3

			
			add		r4.rgba,r0.g,r1.g
			add		r4.rgba,r4,r2.g
			add		r4.rgba,r4,r3.g
			mul		r4.rgba,r4,c0.r
			
			//mov r4.rgba,r0.g
			
			mov		oC0,r4
		};
	}
}
*/
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

technique	tech_soften_shadow
<
	int Priority = 1;
	int TechniqueIndex = 0;
	int DeviceType = HWSHADER_ONLY;
	int LightingType = INTEGRATED_LIGHTING;
	string RenderingType = "Shadow";
>
{
	pass pass1
	{
		CullMode			= NONE;
		ZEnable				= false;
		ZWriteEnable		= false;
		AlphaBlendEnable	= false;
		AlphaTestEnable		= false;
		
		Sampler[0]	= <SoftenSampler>;
		Sampler[1]	= <SoftenSampler>;
		Sampler[2]	= <SoftenSampler>;
		Sampler[3]	= <SoftenSampler>;
		
		VertexShader = compile vs_1_1 VSSoftenShadow();
		
		PixelShaderConstant[0]	= {0.25f,0.25f,0.25f,0.25f};
		
		PixelShader = 
		asm
		{
			ps_1_1
	
			tex	t0
			tex	t1
			tex	t2
			tex	t3
			
			mul		r0,t0,c0
			mad		r0.rgba,t1,c0,r0
			mad		r0.rgba,t2,c0,r0
			mad		r0.rgba,t3,c0,r0
		};
	}
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
/*
technique	tech_soften_shadow_PS20_Pass2
<
	int Priority = 1;
	int TechniqueIndex = 1;
	int DeviceType = HWSHADER_ONLY;
	int LightingType = INTEGRATED_LIGHTING;
	string RenderingType = "Shadow";
>
{
	pass pass1
	{
		CullMode			= NONE;
		ZEnable				= false;
		ZWriteEnable		= false;
		AlphaBlendEnable	= false;
		AlphaTestEnable		= false;
		
		Sampler[0]	= <SoftenSampler>;
		Sampler[1]	= <SoftenSampler>;
		Sampler[2]	= <SoftenSampler>;
		Sampler[3]	= <SoftenSampler>;
		
		VertexShader = compile vs_1_1 VSSoftenShadow();
		
		PixelShaderConstant[0]	= {0.5f,0.0f,0.0f,0.0f};
		
		PixelShader = 
		asm
		{
			ps_2_0
	
			dcl		t0.rg
			dcl		t1.rg
			dcl		t2.rg
			dcl		t3.rg
			dcl_2d	s0
			dcl_2d	s1
			dcl_2d	s2
			dcl_2d	s3
			
			texld	r0,t0,s0
			
			
			texld	r1,t1,s1
			texld	r2,t2,s2
			texld	r3,t3,s3
			
			add		r4.rgba,r0.g,r1.g
			add		r4.rgba,r4,r2.g
			add		r4.rgba,r4,r3.g
			mul		r4.rgba,r4,c0.r
			
			//mov r4.rgba,r0.g
			
			mov		oC0,r4
		};
	}
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

technique	tech_soften_shadow_PS11_Pass2
<
	int Priority = 1;
	int TechniqueIndex = 1;
	int DeviceType = HWSHADER_ONLY;
	int LightingType = INTEGRATED_LIGHTING;
	string RenderingType = "Shadow";
>
{
	pass pass1
	{
		CullMode			= NONE;
		ZEnable				= false;
		ZWriteEnable		= false;
		AlphaBlendEnable	= false;
		AlphaTestEnable		= false;
		
		Sampler[0]	= <SoftenSampler>;
		Sampler[1]	= <SoftenSampler>;
		Sampler[2]	= <SoftenSampler>;
		Sampler[3]	= <SoftenSampler>;
		
		VertexShader = compile vs_1_1 VSSoftenShadow();
		
		PixelShaderConstant[0]	= {0.25f,0.25f,0.25f,0.25f};
		
		PixelShader = 
		asm
		{
			ps_1_1
	
			tex	t0
			tex	t1
			tex	t2
			tex	t3

			mul		r0,t0,c0
			mad		r0.rgba,t1,c0,r0
			mad		r0.rgba,t2,c0,r0
			mad_x2	r0.rgba,t3,c0,r0
		};
	}
}
*/

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------